#ifndef __BE_RADIOADDON__
#define __BE_RADIOADDON__

#include <SupportDefs.h>
#include <image.h>

// radio capabities
#define	RADIO_SET_FREQUENCY			1 << 0		// the card is able to change the frequency
#define	RADIO_GET_FREQUENCY			1 << 1		// the card is able to get the selected frequency
#define	RADIO_SET_VOLUME			1 << 2		// the card is able to change the volume
#define	RADIO_GET_VOLUME			1 << 3		// the card is able to get the volume
#define	RADIO_SET_MUTE				1 << 4		// the card is able to change the mute status
#define	RADIO_GET_MUTED				1 << 5		// the card is able to get the mute status
#define	RADIO_GET_SIGNAL_STATUS		1 << 6		// the card is able to know if the signal is set
#define	RADIO_GET_SIGNAL_STEREO		1 << 7		// the card is able to know if the signal is stereo

class BeRadioAddOn
{
public:
	virtual ~BeRadioAddOn();
	
	virtual const char *	Version(void) = 0;		// version string
	virtual const char *	Name(void) = 0;			// add-on name

	virtual void			Open() = 0;				// open the driver
	virtual bool			IsOpened() = 0;			// check if the driver is open
	virtual void			Close() = 0;			// close the driver

	virtual status_t		InitCheck() = 0;		// check if any error occurs

	virtual uint32			GetCapabilities(void) = 0;		// returns what the card can do

	virtual bool			IsMuted(void) = 0;			// is the radio muted	(not yet implemented)
	virtual void			Mute(bool) = 0;				// set the muted status	(not yet implemented)

	virtual uint32			GetVolume(void) = 0;			// returns the volume	(not yet implemented)
	virtual void			SetVolume(uint32) = 0;			// set the volums		(not yet implemented)

	virtual double			GetFrequency(void) = 0;			// return the frequency (not yet implemented)
	virtual void			SetFrequency(double) = 0;		// set the frequency (104.7 for example)
	
	virtual	bool			IsSignalSet(void) = 0;			// return 1 if the signal is set, or 0
	virtual	bool			IsSignalStereo(void) = 0;		// return 1 if the signal is stereo, or 0
};

extern "C" _EXPORT BeRadioAddOn *instantiate_beradio_addon(image_id id);

#endif

